<?php
//-------------------------------------------------------------------------------
// News Links v1.0
//
// This module allows an administrator to post headline links to other websites
// so that news articles, etc. that may be of interest do not need to reside on
// the local server potentially violating copyright laws.
//
// Author: Chris Bianchi
// E-mail: chrisbianchi@earthlink.net
// Last Updated: December 8, 2003
// Mod For: phpNuke 6.9
//-------------------------------------------------------------------------------

// Make sure that we are accessing the module from phpNuke
if (!eregi("modules.php", $_SERVER['PHP_SELF'])) {
    die ("You can't access this file directly...");
}

// Set up the module for phpNuke
require_once("mainfile.php");
$module_name = basename(dirname(__FILE__));
get_lang($module_name);
$index = 1;

// Display the header information
include("header.php");
OpenTable();
echo "<center><strong>"._NEWSLINKS."</strong></center><br><br>";

// Determine which function should be run
switch($l_op) {
	default:
		f_default();
		f_display();
		break;
	case "AddNews":
		f_default();
		f_display();
		f_addform();
		break;
	case "SubmitNews":
		f_default();
		f_submit();
		f_display();
		break;
	case "Delete":
		f_default();
		f_delete();
		f_display();
		break;
}

// Display the footer information
CloseTable();
include("footer.php");

//---- BELOW IS FUNCTIONS -------------------------------------------------------

// f_default checks the database and spawns the display.
function f_default() {
	global $prefix, $db;
	
	$sql = "DESCRIBE ".$prefix."_newslinks_line";
	$result = $db->sql_query($sql);
	if(!$db->sql_numrows($result)) {
		f_buildtables();
	}
}

// f_buildtables builds tables if it is necessary to do so (fresh installation).
function f_buildtables() {
	global $prefix, $db, $module_name;

	echo _BUILDTABLES."<br>";
	$sql = "CREATE TABLE ".$prefix."_newslinks_line(".
		"line_id INTEGER UNSIGNED,line_title VARCHAR(50),line_url VARCHAR(255),".
		"line_description VARCHAR(255))";
	if(!$db->sql_query($sql)) {
		echo "<strong>"._BUILDTABLESERROR."</strong>";
	} else {
		echo _BUILDTABLESDONE;
	}
	echo "<br><br>";
}

// f_display shows the headlines to the user in a list of links.
function f_display() {
	global $prefix, $db, $module_name, $admin;
	$sql = "SELECT * FROM ".$prefix."_newslinks_line ORDER BY line_id DESC";
	$result = $db->sql_query($sql);
	if(!$db->sql_numrows($result)) {
		echo _NOARTICLES;
	} else {
		$index = 0;
		while($row = $db->sql_fetchrow($result) and $index < 10) {
			echo "<a href=\"".$row["line_url"]."\" target=\"_blank\">";
			echo stripslashes($row["line_title"]).
				"</a><br>".stripslashes($row['line_description']);
			if(is_admin($admin)) {
				echo "<br>[<a href=\"modules.php?name=".$module_name."&l_op=Delete&id=".
					$row['line_id']."\">Delete</a>]";
			}
			echo "<br><br>";
			$index++;
		}
	}
	if(is_admin($admin)) {
		echo "<br><center><a href=\"modules.php?name=".$module_name."&l_op=AddNews\">".
			"Add News</a></center>";
	}
}

// f_addform displays the form necessary to create links.
function f_addform() {
	global $admin, $module_name;
	
	CloseTable();
	echo "<br>";
	OpenTable();
	echo "<center><strong>"._ADDNEWS."</strong></center><br><br>";
	if(is_admin($admin)) {
		echo "<form action=\"modules.php?name=".$module_name."&l_op=SubmitNews\" method=\"POST\">".
			"Title:<br><input type=\"text\" name=\"title\" maxlength=50 size=50%><br>".
			"URL:<br><input type=\"text\" name=\"url\" value=\"http://\" maxlength=255 size=50%><br>".
			"Description:<br><input type=\"text\" name=\"description\" maxlength=255 size=50%><br><br>".
			"<center><input type=\"submit\" value=\"Submit\"></center></form>";
	} else {
		echo _NOPERMISSION;
	}
}

// f_submit enters form information to create the links.
function f_submit() {
	global $prefix, $db, $admin;
	if(is_admin($admin) and isset($_POST['title']) and isset($_POST['url']) and isset($_POST['description'])) {
		$sql = "SELECT MAX(line_id) AS topkey FROM ".$prefix."_newslinks_line";
		$result = $db->sql_query($sql);
		if(!$db->sql_numrows($result)) {
			$thiskey = 0;
		} else {
			$row = $db->sql_fetchrow($result);
			$thiskey = $row['topkey'] + 1;
		}
		$title = addslashes($_POST['title']);
		$url = stripslashes($_POST['url']);
		$description = addslashes($_POST['description']);
		$sql = "INSERT INTO ".$prefix."_newslinks_line values(".$thiskey.",'".$title."','".
			$url."','".$description."')";
		$result = $db->sql_query($sql);
	}
}

// f_delete deletes a specified headline.
function f_delete() {
	global $prefix, $db, $admin, $id;
	if(is_admin($admin) and isset($id)) {
		$sql = "DELETE FROM ".$prefix."_newslinks_line WHERE line_id=".$id;
		$result = $db->sql_query($sql);
	}
}
?>